#ifndef _mat
#define _mat

#define Fmelt(mat,i,j,c)   ( *((mat) + (c) * (i) + (j)) )

#define Smelt(mat,i,j)   \
((i)<(j) ? *((mat) + ((j)*((j)+1))/2 + (i)) : *((mat) +((i)*((i)+1))/2 +(j)) )

#define Smelt_ind(i,j) \
((i)<(j) ? (((j)*((j)+1))/2 + (i)) : (((i)*((i)+1))/2 +(j)))

#define Fmsize(r,c)        ((r) * (c))
#define Smsize(r,c)       (((r) * ((r) + 1)) / 2)

#define Fallocmat(r,c) ((double *)(malloc ((r) * (c) * sizeof(double))))
#define Sallocmat(r,c) \
  ((double *)(malloc (sizeof(double) * (r) * ((c) + 1) / 2)))


long            mx_init        (double *, long, long, double);
long            mx_copy        (double *, double *, long, long);
long            mx_abs         (double *, double *, long, long);
long            mx_plus        (double *, double *, double *, long, long);
long            mx_plustr      (double *, double *, long, long);
long            mx_diff        (double *, double *, double *, long, long);
long            mx_mulscal     (double *, double, double *, long, long);
long            mx_trans       (double *, double *, long, long);
long            mx_mult        (double *, double *, double *, long, long, long, long);
long            mx_trmult      (double *, double *, double *, long, long, long, long);
long            mx_multtr      (double *, double *, double *, long, long, long, long);
long            mx_trmult1     (double *, double *, long, long);
long            mx_trmult2     (double *, double *, long, long);
long            mx_inf         (double *, double *, long, long);
long            mx_diff_abs_inf (double *, double *, double *, long, long);
long            mxs_init       (double *, long, long, double);
long            mxs_copy       (double *, double *, long, long);
long            mxs_plus       (double *, double *, double *, long, long);
long            mxs_diff       (double *, double *, double *, long, long);
long            mxs_mulreal    (double *, double, double *, long, long);
long            mxs_mult       (double *, double *, double *, long, long, long, long);
long            mxs_inf        (double *, double *, long, long);
long            mxs_diff_abs_inf (double *, double *, double *, long, long);
long            mxfs_copy      (double *, double *, long, long);
long            mxsf_copy      (double *, double *, long, long);
long            mxfs_plus      (double *, double *, double *, long, long);
long            mxfs_diff      (double *, double *, double *, long, long);
long            mxsf_diff      (double *, double *, double *, long, long);
long            mxsf_mult      (double *, double *, double *, long, long, long, long);
long            mxsf_multtr    (double *, double *, double *, long, long, long, long);
long            mxfs_mult      (double *, double *, double *, long, long, long, long);
long            mxfs_trmult    (double *, double *, double *, long, long, long, long);
long            mxfs_trmultm   (double *, double *, double *, long, long, long, long);
long            mxfs_mmulttr   (double *, double *, double *, long, long, long, long);
long            mx_print       (double *, long, long);
long            mxs_print      (double *, long, long);
double          *F_alloctemp    (long);
long            mx_inv         (double *, double *, long, long);
long            mxs_inv        (double *, double *, long, long);
long            mx2_inv        (double *, double *);
long            mx3_inv        (double *, double *);
long            mxs2_inv       (double [3], double [3]);
long            mxs3_inv       (double [6], double [6]);

long            mx_fill       (double *,...);
long            mxs_fill      (double *, ...);
void            mxcopy(double *,double *,long);
long            mx_inv_sg      (double *, double *, long, long);
long            mx_lsqr        (double *, double *, double *, long, long);

#endif








